
quit -sim

vlib work  

#mapping work library to current directory
#vmap [-help] [-c] [-del] [<logical_name>] [<path>]
vmap work  

#compile all .v files to work library
#-work <path>       Specify library WORK
#-vlog01compat      Ensure compatibility with Std 1364-2001
#-incr              Enable incremental compilation
#"rtl/*.v"          rtl directory all .v files, support relative path, need to add ""
#vlog

vlog -novopt ../../project/src/serdes/sdi/sdi.vo

vlog -novopt ../../project/src/rgb_to_yc/*.v
vlog -novopt ../../project/src/yc_to_rgb/*.v
vlog -novopt ../../project/src/testpattern.v

#testbench
vlog -novopt ../../tb/monitor/*.v
vlog -novopt ../../tb/prim_sim.v

vlog -novopt ../../tb/tb.v

#complie all .vhd files
#-work <path>       Specify library WORK
#-93                Enable support for VHDL 1076-1993
#-2002              Enable support for VHDL 1076-2002
#vcom


#simulate testbench top file
#-L <libname>                     Search library for design units instantiated from Verilog and for VHDL default component binding
#+nowarn<CODE | Number>           Disable specified warning message  (Example: +nowarnTFMPC)                      
#-t [1|10|100]fs|ps|ns|us|ms|sec  Time resolution limit VHDL default: resolution setting from .ini file) 
#                                 (Verilog default: minimum time_precision in the design)
#-novopt                          Force incremental mode (pre-6.0 behavior)
vsim +nowarnTFMPC -L work  -novopt -l tb.log work.tb 

#generate wave log format(WLF)......
log -r /*

#open wave window
view wave

#add simulation singals
onerror {resume}
quietly WaveActivateNextPane {} 0

add wave -noupdate -divider {input paramters}
add wave -noupdate -radix unsigned    /tb/I_h_total  
add wave -noupdate -radix unsigned    /tb/I_h_sync   
add wave -noupdate -radix unsigned    /tb/I_h_bporch
add wave -noupdate -radix unsigned    /tb/I_h_res   
add wave -noupdate -radix unsigned    /tb/I_v_total 
add wave -noupdate -radix unsigned    /tb/I_v_sync  
add wave -noupdate -radix unsigned    /tb/I_v_bporch
add wave -noupdate -radix unsigned    /tb/I_v_res   
                                                      
add wave -noupdate -divider {output paramters}        
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_WIDTH   
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_HEIGHT  
add wave -noupdate -radix ascii       /tb/BMP_OUTPUTED_NAME 
add wave -noupdate -radix unsigned    /tb/BMP_OUTPUTED_NUMBER  

add wave -noupdate -radix unsigned    /tb/PCS_CLK_PERIOD   
add wave -noupdate -radix unsigned    /tb/DRP_CLK_PERIOD  

add wave -noupdate -divider {driver_inst output}
add wave -noupdate                    /tb/rst_n
add wave -noupdate                    /tb/pixel_clock
add wave -noupdate                    /tb/vsync
add wave -noupdate                    /tb/hsync
add wave -noupdate                    /tb/data_valid
add wave -noupdate -radix hexadecimal /tb/data0_r
add wave -noupdate -radix hexadecimal /tb/data0_g
add wave -noupdate -radix hexadecimal /tb/data0_b

add wave -noupdate -divider {output channel signals}
add wave -noupdate                    /tb/drp_clk
add wave -noupdate                    /tb/pcs_clock 
add wave -noupdate -radix hexadecimal /tb/data_in        
add wave -noupdate -radix hexadecimal /tb/data_link

add wave -noupdate -divider {output channel signals}
add wave -noupdate                    /tb/clk_rx 
add wave -noupdate                    /tb/fld_rx
add wave -noupdate                    /tb/vs_rx  
add wave -noupdate                    /tb/hs_rx  
add wave -noupdate                    /tb/de_rx
add wave -noupdate -radix hexadecimal /tb/data_rx     

add wave -noupdate -divider {monitor input}
add wave -noupdate                    /tb/m_clk
add wave -noupdate                    /tb/m_vs_rgb
add wave -noupdate                    /tb/m_hs_rgb
add wave -noupdate                    /tb/m_de_rgb
add wave -noupdate -radix hexadecimal /tb/m_data0_r
add wave -noupdate -radix hexadecimal /tb/m_data0_g
add wave -noupdate -radix hexadecimal /tb/m_data0_b

add wave -noupdate -divider {monitor signal}
add wave -noupdate -radix unsigned    /tb/monitor_inst/u_video2bmp/bmp_outputed_number
add wave -noupdate                    /tb/monitor_inst/u_video2bmp/vs_i_fall

add wave -noupdate -divider {End signal}

TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {912366093 ps} 0}
configure wave -namecolwidth 150
configure wave -valuecolwidth 100
update
WaveRestoreZoom {891247063 ps} {925431255 ps}


#set run time
run  -all



