//---------------------------------------------------------------------
// File name  : tb.v
// Module name: tb
// Created by : 
// ---------------------------------------------------------------------
// Release history
// ----------------------------------------------------------------------------------
// Ver:    |  Author    | Mod. Date    | Changes Made:
// ----------------------------------------------------------------------------------
// V1.0    | Caojie     | 08/17/23     | Initial version 
// ----------------------------------------------------------------------------------

`timescale 1ns / 1ps

	`define  	SDI_HD_720P60
// 	`define    	SDI_HD_720P50
//	`define		SDI_HD_1080P30
//	`define		SDI_HD_1080P25
//	`define		SDI_HD_1080P24
//	`define		SDI_3G_1080P60
// 	`define    	SDI_3G_1080P50

module tb();

//========================================================
//parameters
`ifdef SDI_HD_720P60
	wire [2:0]  I_rate      = 3'd1    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1280;
	wire [15:0] I_vres      = 16'd720 ;
	wire [2:0]  I_ver_fre   = 3'd0    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd1650;//hor total time 
    wire [15:0] I_h_sync    = 16'd40  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd220 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1280;//hor resolution
    wire [15:0] I_v_total   = 16'd750 ;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd20  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd720 ;//ver resolution 
`endif

`ifdef SDI_HD_720P50
	wire [2:0]  I_rate      = 3'd1    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1280;
	wire [15:0] I_vres      = 16'd720 ;
	wire [2:0]  I_ver_fre   = 3'd1    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd1980;//hor total time 
    wire [15:0] I_h_sync    = 16'd40  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd220 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1280;//hor resolution
    wire [15:0] I_v_total   = 16'd750 ;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd20  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd720 ;//ver resolution 
`endif

`ifdef SDI_HD_1080P30
    reg  [2:0]  I_rate      = 3'd1    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
    reg  [15:0] I_hres      = 16'd1920;
    reg  [15:0] I_vres      = 16'd1080;
    reg  [2:0]  I_ver_fre   = 3'd2    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
    reg         I_interlace = 1'b1    ;//0:interlaced1:progressive
    reg         I_color     = 1'b0    ;//0:YC1:RGB
    reg         I_mfactor   = 1'b0    ;//0:M=11:M=1.001
    reg         I_pixbit    = 1'b0    ;//0:10bit1:12bit
    reg  [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd2200;//hor total time 
    wire [15:0] I_h_sync    = 16'd44  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd148 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1920;//hor resolution
    wire [15:0] I_v_total   = 16'd1125;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd36  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd1080;//ver resolution 	
`endif

`ifdef SDI_HD_1080P25
	wire [2:0]  I_rate      = 3'd1    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1920;
	wire [15:0] I_vres      = 16'd1080;
	wire [2:0]  I_ver_fre   = 3'd3    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd2640;//hor total time 
    wire [15:0] I_h_sync    = 16'd44  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd148 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1920;//hor resolution
    wire [15:0] I_v_total   = 16'd1125;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd36  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd1080;//ver resolution 
`endif

`ifdef SDI_HD_1080P24
	wire [2:0]  I_rate      = 3'd1    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1920;
	wire [15:0] I_vres      = 16'd1080;
	wire [2:0]  I_ver_fre   = 3'd4    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd2750;//hor total time 
    wire [15:0] I_h_sync    = 16'd44  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd148 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1920;//hor resolution
    wire [15:0] I_v_total   = 16'd1125;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd36  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd1080;//ver resolution 
`endif

`ifdef SDI_3G_1080P60
	wire [2:0]  I_rate      = 3'd2    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1920;
	wire [15:0] I_vres      = 16'd1080;
	wire [2:0]  I_ver_fre   = 3'd0    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd2200;//hor total time 
    wire [15:0] I_h_sync    = 16'd44  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd148 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1920;//hor resolution
    wire [15:0] I_v_total   = 16'd1125;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd36  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd1080;//ver resolution 
`endif

`ifdef SDI_3G_1080P50
	wire [2:0]  I_rate      = 3'd2    ;//0:SD-SDI, 1:HD-SDI, 2:3G-SDI, 3:6G-SDI
	wire [15:0] I_hres      = 16'd1920;
	wire [15:0] I_vres      = 16'd1080;
	wire [2:0]  I_ver_fre   = 3'd1    ;//0:60Hz, 1:50Hz, 2:30Hz, 3:25Hz, 4:24Hz
	wire        I_interlace = 1'b1    ;//0:interlaced1:progressive
	wire        I_color     = 1'b0    ;//0:YC1:RGB
	wire        I_mfactor   = 1'b0    ;//0:M=11:M=1.001
	wire        I_pixbit    = 1'b0    ;//0:10bit1:12bit
	wire [1:0]  I_pixstruc  = 2'b00   ;//2'b00:4:2:22'b10:4:4:42'b11:4:4:4:4
	
	wire [15:0] I_h_total   = 16'd2640;//hor total time 
    wire [15:0] I_h_sync    = 16'd44  ;//hor sync time
    wire [15:0] I_h_bporch  = 16'd148 ;//hor back porch
    wire [15:0] I_h_res     = 16'd1920;//hor resolution
    wire [15:0] I_v_total   = 16'd1125;//ver total time 
    wire [15:0] I_v_sync    = 16'd5   ;//ver sync time  
    wire [15:0] I_v_bporch  = 16'd36  ;//ver back porch  
    wire [15:0] I_v_res     = 16'd1080;//ver resolution 
`endif
								   
parameter BMP_OUTPUTED_WIDTH	   = 1280;
parameter BMP_OUTPUTED_HEIGHT	   = 720;
parameter BMP_OUTPUTED_NAME		   = "../../tb/pic/out0_001.bmp";
parameter BMP_OUTPUTED_NUMBER	   = 16'd3;

parameter PCS_CLK_PERIOD	       = 13.468; //unit: ns  1000/74.25MHz=13.468ns
parameter DRP_CLK_PERIOD	       = 20.0; //unit: ns  1000/50MHz=20ns

//=======================================================
reg  pcs_clock;
reg  drp_clk;
wire pixel_clock;

reg  rst_n;

//------------
//dirver
wire [15:0] vs_cnt;
wire [15:0] hs_cnt;
wire        vsync; 
wire        hsync; 
wire        data_valid; 
wire [7:0]  data0_r; 
wire [7:0]  data0_g;
wire [7:0]  data0_b;

//----------------------
wire [15:0] vs_cnt_yc;
wire [15:0] hs_cnt_yc;
wire        fld_yc;
wire        vs_yc;  
wire        hs_yc;  
wire        de_yc;
wire [15:0] data_yc;

//---------------------
wire        fld_in;
wire        vs_in;  
wire        hs_in;  
wire        de_in;
wire [19:0] data_in;

//--------------
wire [79:0] data_link;

//-------------
wire        clk_rx;
wire        fld_rx;
wire        vs_rx;  
wire        hs_rx;  
wire        de_rx;
wire [19:0] data_rx;

wire [15:0] rx_hcnt ;
wire [15:0] rx_vcnt ;

reg         vs_rx_gen;
reg         hs_rx_gen;

//---------------
wire        yc422_clk_in ;
wire        yc422_vs_in  ;  
wire        yc422_hs_in  ;  
wire        yc422_de_in  ;
wire [15:0] yc422_data_in;

//--------------
wire        vs_rgb;  
wire        hs_rgb;  
wire        de_rgb;  
wire [7:0]  data_rgb_r;
wire [7:0]  data_rgb_g;
wire [7:0]  data_rgb_b;

//-----------------
//monitor rgb input
wire		m_clk;
wire		m_vs_rgb;  
wire		m_hs_rgb;  
wire		m_de_rgb;  
wire [7:0]  m_data0_r;
wire [7:0]  m_data0_g;
wire [7:0]  m_data0_b;
wire [7:0]  m_data1_r;
wire [7:0]  m_data1_g;
wire [7:0]  m_data1_b;

//=====================================================
GSR GSR(.GSRI(1'b1));

//==============================================  
initial begin
  $fsdbDumpfile("tb.fsdb");
  $fsdbDumpvars;
end

//=====================================================
//pixel_clk
initial
  begin
	pcs_clock	     = 1'b0;
    drp_clk          = 1'b0;
  end

always  #(PCS_CLK_PERIOD/2.0) pcs_clock = ~pcs_clock;
always  #(DRP_CLK_PERIOD/2.0) drp_clk = ~drp_clk;


//=====================================================
//rst_n
initial
  begin
	rst_n=1'b0;
	
	#2000;
	rst_n=1'b1;
end

//==================================================
//video driver
testpattern testpattern_inst
(
	.I_pxl_clk   (pixel_clock        ),//pixel clock
	.I_rst_n     (rst_n             ),//low active 
	.I_mode      (3'b000             ),//data select
    .I_sqr_width (16'd60             ),
	.I_single_r  (8'd0               ),
	.I_single_g  (8'd255             ),                  //74.25MHz  //148.5MHz 
	.I_single_b  (8'd0               ),                  //1280x720  //1920x1080   
	.I_h_total   (I_h_total          ),//hor total time  // 16'd1650 // 16'd2200  
	.I_h_sync    (I_h_sync           ),//hor sync time   // 16'd40   // 16'd44    
	.I_h_bporch  (I_h_bporch         ),//hor back porch  // 16'd220  // 16'd148   
	.I_h_res     (I_h_res            ),//hor resolution  // 16'd1280 // 16'd1920  
	.I_v_total   (I_v_total          ),//ver total time  // 16'd750  // 16'd1125   
	.I_v_sync    (I_v_sync           ),//ver sync time   // 16'd5    // 16'd5     
	.I_v_bporch  (I_v_bporch         ),//ver back porch  // 16'd20   // 16'd36    
	.I_v_res     (I_v_res            ),//ver resolution  // 16'd720  // 16'd1080   
	.I_hs_pol    (1'b1               ),//HS polarity , 0:negetive ploarity1positive polarity
	.I_vs_pol    (1'b1               ),//VS polarity , 0:negetive ploarity1positive polarity
    .O_V_cnt     (vs_cnt             ),
    .O_H_cnt     (hs_cnt             ),
	.O_de        (data_valid         ),   
	.O_hs        (hsync              ),
	.O_vs        (vsync              ),
	.O_data_r    (data0_r            ),   
	.O_data_g    (data0_g            ),
	.O_data_b    (data0_b            )
);

//==============================================
//rgb to yc422
rgb_yc422 rgb_yc422_inst
(
`ifdef SD_SDI
    .pix_clk   (           ),
`else
    .pix_clk   (pixel_clock), 
`endif 
    .rst_n     (rst_n      ),
    .odd_even  (1'b0       ), //default 0
    .vs_cnt_i  (vs_cnt     ),
    .hs_cnt_i  (hs_cnt     ),
    .fld_i     (1'b0       ),
    .hs_i      (hsync      ),
    .vs_i      (vsync      ),
    .din_valid (data_valid ),      
    .r_in      (data0_r    ),       
    .g_in      (data0_g    ),       
    .b_in      (data0_b    ), 
    .vs_cnt_o  (vs_cnt_yc  ),
    .hs_cnt_o  (hs_cnt_yc  ),
    .dout_valid(de_yc      ), 
    .fld_o     (fld_yc     ),
    .hs_o      (hs_yc      ),
    .vs_o      (vs_yc      ),
    .ycbcr422  (data_yc    )
);

//==============================================
    assign fld_in  = fld_yc;
    assign vs_in   = vs_yc ;  
    assign hs_in   = hs_yc ;  
    assign de_in   = de_yc ;
    assign data_in = {data_yc[7:0],2'd0,data_yc[15:8],2'd0};//{C,Y}
    
//=================================================
//SDI IP 
SDI_Top SDI_Top_inst 
(
    .sdi_pma_rst_n_i       (rst_n           ),
                                            
    .sdi_tx_rst_n_i        (rst_n           ),
    .sdi_tx_rate_i         (I_rate          ),
    .sdi_tx_hres_i         (I_hres			),
    .sdi_tx_vres_i         (I_vres			),
    .sdi_tx_ver_fre_i      (I_ver_fre       ),
    .sdi_tx_interlace_i    (I_interlace     ),
    .sdi_tx_color_i        (I_color         ),
    .sdi_tx_mfactor_i      (I_mfactor       ),
    .sdi_tx_pixbit_i       (I_pixbit        ),
    .sdi_tx_pixstruc_i     (I_pixstruc      ),
    .sdi_tx_fld_i          (fld_in			),
    .sdi_tx_vs_i           (vs_in			),
    .sdi_tx_hs_i           (hs_in			),
    .sdi_tx_de_i           (de_in			),
    .sdi_tx_data_i         (data_in		    ),
    .sdi_tx_half_clk_o     (pixel_clock     ),
    
    .sdi_rx_rst_n_i        (rst_n           ),
    .sdi_rx_drp_clk_i      (drp_clk         ),
    .sdi_rx_fix_rate_en_i  (1'b1			),
    .sdi_rx_fix_rate_i     (I_rate          ),
    .sdi_rx_fix_mfactor_i  (I_mfactor       ),
    .sdi_rx_hres_o         (                ),
    .sdi_rx_vres_o         (                ),
    .sdi_rx_interlace_o    (                ),
    .sdi_rx_rate_o         (                ),
    .sdi_rx_mod_o          (                ),
    .sdi_rx_hcnt_o         (rx_hcnt		    ),
    .sdi_rx_vcnt_o         (rx_vcnt		    ),
    .sdi_rx_clk_o          (clk_rx			),
    .sdi_rx_f_o            (fld_rx			),
    .sdi_rx_v_o            (vs_rx			),
    .sdi_rx_h_o            (hs_rx			),
    .sdi_rx_de_o           (de_rx			),
    .sdi_rx_data20_o       (data_rx		    ),
    
    .serdes_pma_rst_n_o    (),
    .serdes_fabric_tx_clk_o(),
    .serdes_txdata_o       (data_link),//[79:0]
    .serdes_tx_fifo_wren_o (),
    .serdes_pcs_tx_rst_o   (),
    .serdes_fabric_rx_clk_o(),
    .serdes_rx_fifo_rden_o (),
    .serdes_rxdata_i       ({8'd0,data_link}),//[87:0]
    .serdes_pcs_rx_rst_o   (),
    .serdes_pcs_tx_clk_i   (pcs_clock),
    .serdes_pcs_rx_clk_i   (pcs_clock)
);

//=================================================
always@(posedge clk_rx or negedge rst_n)
begin
    if(!rst_n)
        vs_rx_gen <= 1'b0;
    else if(rx_vcnt>=1 && rx_vcnt<=5)
        vs_rx_gen <= 1'b1;
    else
        vs_rx_gen <= 1'b0;
end

always@(posedge clk_rx or negedge rst_n)
begin
    if(!rst_n)
        hs_rx_gen <= 1'b0;
    else if(rx_hcnt>=10 && rx_hcnt<=72)
        hs_rx_gen <= 1'b1;
    else
        hs_rx_gen <= 1'b0;
end

    assign yc422_clk_in  = clk_rx    ; 
    assign yc422_vs_in   = vs_rx_gen ;//vs_rx     ;  
    assign yc422_hs_in   = hs_rx_gen ;//hs_rx     ;  
    assign yc422_de_in   = de_rx     ;
    assign yc422_data_in = {data_rx[9:2],data_rx[19:12]};

//==============================================
//yc422 to rgb
yc422_rgb yc422_rgb_inst
(
    .rst_ni          (rst_n        ),          
    .pxclk_i         (yc422_clk_in ),        
    .cb_cr_first_en_i(1'b0         ),//default 0
    .ycbcr422_vs_i   (yc422_vs_in  ),   
    .ycbcr422_hs_i   (yc422_hs_in  ),   
    .ycbcr422_de_i   (yc422_de_in  ),   
    .ycbcr422_data_i (yc422_data_in), 
    .rgb_vs_o        (vs_rgb       ),        
    .rgb_hs_o        (hs_rgb       ),        
    .rgb_de_o        (de_rgb       ),       //---- delay 6 clock     
    .rgb_r_o         (data_rgb_r   ),         
    .rgb_g_o         (data_rgb_g   ),         
    .rgb_b_o         (data_rgb_b   )         
);

//======================================================
//monitor
assign m_clk     = yc422_clk_in       ;
assign m_vs_rgb  = vs_rgb         ;
assign m_hs_rgb  = hs_rgb         ;
assign m_de_rgb  = de_rgb         ;
assign m_data0_r = data_rgb_r     ;
assign m_data0_g = data_rgb_g     ;
assign m_data0_b = data_rgb_b     ;
assign m_data1_r = 8'd0           ;
assign m_data1_g = 8'd0           ;
assign m_data1_b = 8'd0           ;

monitor#
(
  .BMP_OUTPUTED_WIDTH  (BMP_OUTPUTED_WIDTH ),
  .BMP_OUTPUTED_HEIGHT (BMP_OUTPUTED_HEIGHT),
  .BMP_OUTPUTED_NAME   (BMP_OUTPUTED_NAME  ),
  .BMP_OUTPUTED_NUMBER (BMP_OUTPUTED_NUMBER)
)
monitor_inst
(
  .link_i	    (BMP_LINK	), //0,أ1˫
  .video2bmp_en (rst_n		),
  .pixel_clock  (m_clk		), 
  .vsync		(m_vs_rgb	), //	   
  .hsync		(m_hs_rgb	), //	   
  .data_valid   (m_de_rgb	), 
  .data0_r	    (m_data0_r	),	
  .data0_g	    (m_data0_g	),
  .data0_b	    (m_data0_b	),
  .data1_r	    (m_data1_r	),	
  .data1_g	    (m_data1_g	),
  .data1_b	    (m_data1_b	)
);
		  
endmodule
